#!/usr/local/bin/python3.3

##################################################################
from resultmacros import data
##################################################################

venues =    [
             'Asplos',
             'Ccs',
             'Oopsla',
             'Osdi',
             'Pldi',
             'Sigmod',
             'Sosp',
             'Taco',
             'Tissec',
             'Tocs',
             'Tods',
             'Toplas',
             'Vldb',
            ]

type =      [
             'Journals',
             'Conferences',
            ]

NSF =      [
             'NoNSF',
             'NSF',
            ]

Commercial = [
             'CommercialNone',
             'CommercialPart',
             'CommercialFull',
            ]

##################################################################
# Data extraction functions
##################################################################
def val(k,w):
   return data[k + w]

def vsum(k,ws):
   s = 0
   for i in ws:
      s += val(k,i)
   return s

def name(k,w):
   return k + w

def names(k,ws):
   s = ''
   for i in ws:
      if s == "":
         s = name(k,i)
      else:
         s = s + ' + ' + name(k,i) 
   return s

##################################################################
# Assertion 
##################################################################
def ASSERT(lhs,rhs):
   lhsv = vsum(i,lhs)
   rhsv = vsum(i,rhs)
   lhsn = names(i,lhs)
   rhsn = names(i,rhs)
   if lhsv != rhsv:
      print("{0}({1})!=({2})[{3}]".format(lhsn,lhsv,rhsv,rhsn))

def ASSERTSUM(w, venuesSet):
   lhsn = name('Total',w)
   lhsv = val('Total',w)
   rhs = []
   rhsn = ''
   for v in venuesSet:
      rhs.append(val(v,w))
      if rhsn == '':
         rhsn = name(v,w)
      else:
         rhsn = rhsn + '+' + name(v,w)
   rhsv = sum(rhs)
   if lhsv != rhsv:
      print("{0}({1})!=({2})[{3}]".format(lhsn,lhsv,rhsn,rhsv))

##################################################################
# EQUATIONS:
#   Total = WithNoImplementation + WithImplementation
#   WithImplementation = WithArticleCode + WithGoogleCode + WithEmailCode +
#                            (EmailWithoutReply + EmailGotReplyNo) +
#                            EmailNeededNotSent
#   WithAvailableCode = WithArticleCode + WithGoogleCode + WithEmailCode
#   WithAvailableCode = BuildDoesNotCompile +
#                            (BuildRuns + BuildOnlineRuns) +
#                            (BuildCompilesDoesNotRun + BuildOnlineDoesNotRun)

for i in venues:
   ASSERT(['Total'], 
          ['WithNoImplementation','WithImplementation', 'WithHardware'])
   ASSERT(['WithImplementation'],
          ['WithArticleCode','WithGoogleCode','WithEmailCode','EmailWithoutReply','EmailGotReplyNo','EmailNeededNotSent'])
   ASSERT(['WithAvailableCode'],
          ['WithArticleCode','WithGoogleCode','WithEmailCode'])
   ASSERT(['WithAvailableCode'],
          ['BuildDoesNotCompile','BuildRuns','BuildOnlineRuns','BuildCompilesDoesNotRun','BuildOnlineDoesNotRun'])
   ASSERT(['EmailSent'],
          ['EmailGotReplyYes','EmailGotReplyNo','EmailWithoutReply'])

whats = [
   'BuildCompilesDoesNotRun',
   'BuildDoesNotCompile',
   'BuildOnlineDoesNotRun',
   'BuildOnlineRuns',
   'BuildRuns',
   'EmailGotReplyNo',
   'EmailGotReplyYes',
   'EmailNeededNotSent',
   'EmailSent',
   'EmailWithoutReply',
   'WithArticleCode',
   'WithAvailableCode',
   'WithEmailCode',
   'WithGoogleCode',
   'WithImplementation',
   'WithNoImplementation',
]

for w in whats:
   for v in [venues,type,NSF,Commercial]:
      ASSERTSUM(w,v)
