BEGIN {
   FS = "\t"
   BIBTEX_SOURCE = 0
}

{
LABEL = $1
BIBTEX = $2
PAPERLINK = $3
COMMERCIAL = $4
TOOLNAME = $5
IMPLEMENTED = $6
URL_IN_PAPER = $7
URL_FROM_GOOGLE = $8
AUTHOR_EMAIL = $9
GRANTS = $10
URL_FROM_EMAIL = $11
SUCCESSFUL_DOWNLOAD = $12
SUCCESSFUL_BUILD = $13
SUCCESSFUL_RUN = $14
STATUS_ANALYIS = $15
STATUS_EMAIL = $16
COMMENTS = $17
TIME_SPENT = $18
PERSON = $19
COMMENT_CC = $20
COMMENT_TP = $21

#   print "LABEL " LABEL
   if (BIBTEX_SOURCE) {
       split(BIBTEX,B,"{")
       split(B[2],A,",")
       NAME = A[1]
   } else {
      n = split(BIBTEX,B,"/")
      NAME = B[n]
   }
   system("mkdir " NAME)

   orig = NAME "/from_spreadsheet.txt"
   print $0 > orig
   close(orig)

   if (BIBTEX_SOURCE) {
       gsub("},","},\n",BIBTEX)
       gsub("   title","\n   title",BIBTEX)
       print BIBTEX > NAME "/paper.bib"
       close(NAME "/paper.bib")
   } else {
      system("wget -O /tmp/wget.out " BIBTEX)
      system("gawk -f ../extract_bibtex.awk /tmp/wget.out > " NAME "/paper.bib")
   }

   file = NAME "/data.txt"

   print "BIBTEX_LABEL " NAME > file
   if (BIBTEX_SOURCE) {
      print "BIBTEX_URL " >> file
   } else {
      print "BIBTEX_URL " BIBTEX >> file
   }
   print "PAPER_URL " PAPERLINK >> file
   print "COMMERCIAL " COMMERCIAL >> file
   print "TOOLNAME " TOOLNAME >> file
   print "IMPLEMENTED " IMPLEMENTED >> file
   print "TOOL_URL_IN_PAPER " URL_IN_PAPER >> file
   print "TOOL_URL_FROM_GOOGLE " URL_FROM_GOOGLE >> file
   print "TOOL_URL_FROM_EMAIL " URL_FROM_EMAIL >> file
   print "AUTHOR_EMAIL " AUTHOR_EMAIL >> file
   print "GRANTS " GRANTS >> file
   print "SUCCESSFUL_DOWNLOAD " SUCCESSFUL_DOWNLOAD >> file
   print "SUCCESSFUL_BUILD " SUCCESSFUL_BUILD >> file
   print "SUCCESSFUL_RUN " SUCCESSFUL_RUN >> file
   print "STATUS_ANALYIS " STATUS_ANALYIS >> file
   print "STATUS_EMAIL " STATUS_EMAIL >> file
   print "COMMENTS " COMMENTS >> file
   print "COMMENT_CC " COMMENT_CC >> file
   print "COMMENT_TP " COMMENT_TP >> file
   print "TIME_SPENT " TIME_SPENT >> file
   print "PERSON " PERSON >> file
   close(file)
}