#!/bin/bash

gawk 	'{
		i++
		if($0!~/#/) {
			if(NF>1 && $NF!=0){
				split($0, a, "\"")
				label[i] = a[2]
				#label[i] = $1
				v[i] = $NF
				D+= $NF
			}
			else if(NF==1){
				i--;
				split($0, a, ":")
				confname = a[2]
				#print "Conference name saved\n"
			}
			else{
				i--
			}
	    }
	}
	END {	
		d = v[1]
		print "set terminal pngcairo size 800,500 "
		printf "set output \"./pie/%s-pie.png\"\n", confname
		print "reset"
		printf "set title \"%s\"\n", confname
		print "b=0.20; s=7; B=0.5; txt=0.4"
		print "unset border; unset tics; unset key"
		print "set angles degree; set yrange [0:1]; set style fill solid 1.0 border -1"

		for(j=1;j<=i;j++) {
			v_orig[j] = v[j]
		}

		for(j=1;j<=i;j++) {
			v[j] = v[j]/D
			if(j>1){
				v[j] += v[j - 1]
			}
		}

		for(j=1;j<=i;j++) {
			v[j] = v[j]*360
		}

		tot = 0
		for(j=1;j<=i;j++) {
			d=v[j]
			color = 1
			#"no imp" 0
			#"no/bkn lnk" 0
			#"lnk no run" 0
			#"builds runs" 0
			#"lnk but ukn build" 0

			switch (label[j]) {
    		case "no imp":
   	    	  	color = 9
        		break
    	 	case "no/bkn lnk":
   	    	  	color = 6
        		break
    	 	case "lnk no run":
   	  	  	  	color = 1
        		break	
    	 	case "builds runs":
   	    	  	color = 2
        		break
    	 	case "lnk but ukn build":
   	    	  	color = 3
        		break
    	 	default:
   	    	  	color = 1
   		  	}

			printf "set obj %d circle arc [%g:%g] fc lt %d \n", j, tot, d, color
			printf "set obj %d circle at screen B,B size screen b front \n", j
			tot=d
		}

		print "set font \"arial\""
		#pre=0
		#next=v[1]
		v[0] = 0
		for(j=0;j<i;j++) {
			d = ( v[j] + v[j+1] )/2
			p = (v[j+1] - v[j]) / 3.6
			printf "set label at screen %d \" %s:%02.01f%s/%s \" at s * cos(%f) - 2.2, B+0.02+0.5*sin(%f) font \", 12\"\n", j + 1, label[j + 1], p, "%", v_orig[j+1], d, d, d, d
		}
		print "plot 2"
	}' $1